import Database from "../../../../../Components/common/Database";
import NetInfo from "@react-native-community/netinfo";
import { async } from "validate.js";

// save data in realm
export const offlinePIDataToRealm = () => {
  try {
    let realm = Database.getRealm();
    let offlineImageData = [];
    const mediaStatusObjs = realm.objects("PIMediaStatus");
    const vechicleData = realm.objects("PIVechicleData");
    console.log(
      "CommonFunc  offlinePIDataToRealm() mediaStatusObjs \n\n\n ",
      mediaStatusObjs
    );
    offlineImageData = [];
    mediaStatusObjs.filter((item) => {
      if (item?.status === "failed") {
        offlineImageData.push(item);
      }
    });
    realm.write(() => {
      realm.delete(realm.objects("PIOfflineVechicleData"));
      realm.create("PIOfflineVechicleData", {
        activityId: "",
        registrationNumber: vechicleData[0]?.licensePlateNumber,
        quoteNumber: vechicleData[0]?.quoteNumber,
        dataTobeUploaded: JSON.stringify(offlineImageData),
      });
    });
    console.log(
      "Data after PIOfflineVechicleData",
      realm.objects("PIOfflineVechicleData")
    );
    clearAllRealmData();
  } catch (error) {}
};

// checking internet
export const checkInternet = async () => {
  const state = await NetInfo.fetch();
  console.log("Connection type", state.type);
  console.log("Is connected?", state.isConnected);
  return state.isConnected;
};

// make desion for offline/online flow
export const checkFlow = () => {};

export const clearAllRealmData = () => {
  try {
    let realm = Database.getRealm();
    realm.write(() => {
      realm.delete(realm.objects("PIOfflineData"));
    });
    realm.write(() => {
      realm.delete(realm.objects("PIVechicleData"));
    });
    realm.write(() => {
      realm.delete(realm.objects("PIVechicleInstruction"));
    });
    realm.write(() => {
      realm.delete(realm.objects("PIGonePoseDetection"));
      realm.create("PIGonePoseDetection", {
        GoneposeDetectionCount: 0,
      });
    });

    realm.write(() => {
      realm.delete(realm.objects("PIPoseDetectionCompleted"));
      realm.create("PIPoseDetectionCompleted", {
        poseDetectionCompletedCount: 0,
      });
    });

    realm.write(() => {
      realm.delete(realm.objects("PIRetryCount"));
      realm.create("PIRetryCount", {
        retryCount: 0,
        index: 0,
        isAddNewImageData: false,
      });
    });

    realm.write(() => {
      realm.delete(realm.objects("PIclickedCount"));
      realm.create("PIclickedCount", {
        clickedCount: 0,
      });
    });

    realm.write(() => {
      realm.delete(realm.objects("PIUploadedCount"));
      realm.create("PIUploadedCount", {
        uploadedCount: 0,
      });
    });
    realm.write(() => {
      realm.delete(realm.objects("PIMediaStatus"));
    });
    realm.write(() => {
      realm.delete(realm.objects("PIVideoCompleteStatus"));
    });
  } catch (error) {}
};

export const updateStatusRealm = (uri, DocumentImageName, newStatus) => {
  let realm = Database.getRealm();
  var PIVechicleData = realm.objects("PIVechicleData");
  var activityId = PIVechicleData[0]?.activityId;
  var quoteNumber = PIVechicleData[0]?.quoteNumber;
  var licensePlateNumber = PIVechicleData[0]?.licensePlateNumber;

  realm.write(() => {
    realm.create("PIMediaStatus", {
      status: newStatus, // uploading, uploaded, failed
      uri: uri,
      imageName: DocumentImageName,
      activityId: activityId,
      quoteNumber: quoteNumber,
      regNumber: licensePlateNumber,
    });
  });
};
