import {
  Alert,
  Image,
  StyleSheet,
  Text,
  View,
  KeyboardAvoidingView,
  BackHandler,
  Platform,
} from "react-native";
import React, { useEffect, useRef, useState } from "react";
import Header from "../Screens/Header";
import { translate } from "react-native-digitcamera/src/common/localize/i18n";
import Orientation from "../../../react-native-orientation";
import {
  TextInput,
  PrimaryButton,
  RoundButton,
  Spinner,
} from "../common/ThemedComponents";
import { renderErrorMsge } from "react-native-digitcamera/src/common/Validation";
import { ScrollView } from "react-native-gesture-handler";
import { async } from "validate.js";
import { getActivityid } from "react-native-digitcamera/src/common/Services/getActivityid";
import { useDispatch } from "react-redux";
import Modal from "../common/Modal";
import Database from "../../../../Components/common/Database";
import {
  POLICY_NUMBER_REGX,
  SCREEN_HEIGHT,
  SCREEN_WIDTH,
} from "react-native-digitcamera/src/common/Constants";
import {
  firebaseAttributes,
  errorRecord,
  firebaseEvents,
} from "../common/libEventLog/libCrashlytics/libCrashlyticsEvent";
import analytics from "@react-native-firebase/analytics";
import Colors from "react-native-digitcamera/src/common/Colors";
import Icon from "react-native-vector-icons/MaterialCommunityIcons";
import MIcon from "react-native-vector-icons/MaterialIcons";
import NetInfo from "@react-native-community/netinfo";
import UploadFile from "react-native-digitcamera/src/Screens/UploadFile";
import ProductCard from "react-native-digitcamera/src/common/ProductCard";

import {
  UELogEvent,
  UELogMessage,
} from "../common/libEventLog/UserExperior/LibUserExperior";
import style from "../../../../Components/common/CommonStyle";
import ImagePlaceholder from "react-native-digitcamera/src/common/ImagePlaceholder";

let realm = Database.getRealm();
var AppLoginStatus = realm.objects("AppLoginStatus");

var PICompleteStatus = realm.objects("PICompleteStatus");
var PIRetryCount = realm.objects("PIRetryCount");
var PILocation = realm.objects("PILocation");


const iOS = Platform.OS === "ios";

const girl_selfi = require("../common/Image/girl_selfi.png");
const car = require("../common/Image/car.png");
const Bike = require("../common/Image/Bike.png");
const cummercial = require("../common/Image/cummercial.png");
var sensorImageDetails = [];

const WithQuote = ({ navigation, route }) => {
  const [_4Wclicked, set4wclicked] = useState(false);
  const [_2Wclicked, set2wclicked] = useState(false);
  const [cvclicked, setCVclicked] = useState(false);

  const [quoteNumber, setQuoteNumber] = useState("D300090553");
  const [isLoading, setISsLoading] = useState(false);
  const [isPIModalVisible, setisPIModalVisible] = useState(false);
  const [, updateState] = React.useState();
  const forceUpdate = React.useCallback(() => updateState({}), []);

  const [showOfflineModal, setShowOfflineModal] = useState(false);
  const [isNetworkAvailable, setIsNetworkAvailable] = useState(true);
  const [isVechicleTypeSelected, setIsVechicleTypeSelected] = useState(false);
  const [activityTypeId, setActivityTypeId] = useState(0);
  const [vechicleType, setVechicleType] = useState("");

  var vechicleData = realm.objects("PIVechicleData");
  var registrationNumber;
  const [wrongQuoteModalVisible, setWrongQuoteModalVisible] = useState(false);
  const dispatch = useDispatch();
  const { agentEmail, agentName, agentMobile, toWithQuote, toTutorial } =
    route.params;

  var activityData;

  useEffect(() => {
    if (!iOS) {
      const Immersive = require("react-native-immersive").Immersive;
      Immersive.setImmersive(false);
    }
    Orientation.lockToPortrait();
    let realm = Database.getRealm();

    var isFromLink = realm.objects("PIDeeplink")[0].isFromLink;

    if (isFromLink) {
      navigation.navigate("Toturial");
    }

    let unsubscribe = navigation.addListener("focus", () => {
      if (!iOS) {
        const Immersive = require("react-native-immersive").Immersive;
        Immersive.setImmersive(false);
      }

      // excute on again back on same screen
      checkInternetAndGetInstruction();
      console.log("Calling from frocus ::::: : :: ::::: ");

      // this flow will excute only when app is not loging and user come through otp validation screen
      // if user come through the link then we are storing the flag in APP's App.js from their according to flag we are navigating to the screen
      if (isFromLink) {
        navigation.navigate("Toturial");
      }
      Orientation.lockToPortrait();
    });
    checkInternetAndGetInstruction();
    console.log("Calling from useEffect ::::: : :: ::::: ");

    return () => {
      unsubscribe();
    };
  }, [isNetworkAvailable]);

  const checkInternetAndGetInstruction = () => {
    try {
      const unsubscribeNetInfo = NetInfo.addEventListener(async (state) => {
        if (state.isInternetReachable != null) {
          if (state.isInternetReachable) {
            setShowOfflineModal(false);
            setIsNetworkAvailable(true);
            // this block exicute when internet is connected and we have a offlineData to upload
            let offlineImageData = realm.objects("PIOfflineVechicleData");
            let activityTypeId = JSON.parse(
              offlineImageData[0]?.dataTobeUploaded
            )[0].activityId;
            let registrationNumber = offlineImageData[0]?.registrationNumber;
            let quoteNumber = offlineImageData[0]?.quoteNumber;

            if (offlineImageData.length > 0) {
              // data present
              // upload images which are in offline Db navigate to videoPIProgress

              try {
                //API call
                const { getUserDetails } = require("../common/Who");
                getUserDetails(realm);
                const {
                  emailId,
                  name,
                  phoneNo,
                  panHolderName,
                  panNo,
                  agentNumber,
                } = require("../common/Who");

                const body = {
                  activityTypeId: activityTypeId,
                  customerDetailData: {
                    emailId: emailId,
                    name: name,
                    phoneNo: phoneNo,
                    panHolderName: panHolderName,
                    panNo: panNo,
                  },
                  agentId: agentNumber,
                  licensePlateNumber: registrationNumber,
                  previousPolicyExpired: true,
                  quoteNumber: offlineImageData[0]?.quoteNumber,
                };

                activityData = await getActivityid({ body });
                registrationNumber =
                  activityData?.additionalActivitiesList.filter((item) => {
                    if (item.key == "Registration Number") {
                      return item;
                    }
                  });
                let userNCB = activityData?.additionalActivitiesList.filter(
                  (item) => {
                    if (item.key == "User NCB") {
                      return item;
                    }
                  }
                );
                setISsLoading(false); // adding data to redux

                dispatch({
                  type: "ACTIVITY_DATA",
                  payload: {
                    activityId: activityData?.activityID,
                    activityTypeId: activityData?.activityTypeId,
                    licensePlateNumber:
                      registrationNumber === undefined
                        ? ""
                        : registrationNumber[0].value,
                    toWithQuote: toWithQuote,
                    toTutorial: toTutorial,
                    quoteNumber: quoteNumber,
                  },
                });
                realm.write(() => {
                  realm.delete(realm.objects("PIVechicleData"));
                  realm.create("PIVechicleData", {
                    activityId: activityData?.activityID,
                    activityTypeId: activityData?.activityTypeId,
                    licensePlateNumber:
                      registrationNumber === undefined
                        ? ""
                        : registrationNumber[0].value,
                    toWithQuote: toWithQuote,
                    toTutorial: toTutorial,
                    quoteNumber: quoteNumber,
                    ncb:
                      userNCB === undefined || userNCB.length == 0
                        ? 0
                        : Number(userNCB[0].value),
                    vechicleType: "",
                  });
                });

                console.log(
                  "Offline Data Length   :::::::::::::::      ::: ::: ::: >",
                  JSON.stringify(offlineImageData.length, null, "  ")
                );

                // clearing database
                realm.write(() => {
                  realm.delete(realm.objects("PIMediaStatus"));
                });
                JSON.parse(offlineImageData[0].dataTobeUploaded).map(
                  (dataTobeUploaded) => {
                    let uri = dataTobeUploaded?.uri;
                    let imageName = dataTobeUploaded?.imageName;
                    let ext = imageName == "VDO" ? ".mp4" : ".jpg";
                     UploadFile(
                      uri,
                      imageName,
                      ext,
                      () => {
                        props.navigation.navigate("WithQuote");
                      },
                      () => {
                        addSensorImageData(ext, true,imageName);
                      },
                      () => {
                        addSensorImageData(ext, false,imageName);
                      }
                    );
                  }
                );
                navigation.navigate("VideoPIProgress");
              } catch (error) {}
            } else {
              // nothing to do
              // app will work on online flow
            }
          } else {
            // use static data and continue the flow
            setIsNetworkAvailable(false);
          }
        }
        forceUpdate();
      });

      return () => {
        unsubscribeNetInfo();
      };
    } catch (error) {
      console.log("Error : checkInternetAndGetInstruction ", error);
    }
  };


  const addSensorImageData = (ext, ImageStatus,docName) => {
    var currentLatitude = PILocation[0]?.lat;
 var currentLongitude = PILocation[0]?.long;
     let imageName = docName;
     var attemptCount = PIRetryCount[0]?.retryCount + 1;
     var fileName = activityData?.activityID + "_" + imageName + ext;
     //adding sensor data
     sensorImageDetails.push({
       attemptCount: attemptCount,
       fileName: fileName,
       latitude: currentLatitude,
       longitude: currentLongitude,
       pose: imageName,
       success: ImageStatus,
       timestamp: new Date().getTime(),
     });
     dispatch({
       type: "SENSOR_DETAILS",
       payload: sensorImageDetails,
     });
   };
   
  //to get activity id and activityTypeid
  const callGetActivityid = async () => {
    try {
      /* wrong quote number modal */
      if (quoteNumber.match(POLICY_NUMBER_REGX) == null) {
        if (!wrongQuoteModalVisible) {
          setWrongQuoteModalVisible(true);
          setISsLoading(false);
          return;
        }
      }
      //API call
      const { getUserDetails } = require("../common/Who");
      getUserDetails(realm);
      const {
        emailId,
        name,
        phoneNo,
        panHolderName,
        panNo,
        agentNumber,
      } = require("../common/Who");

      const AppLoginStatus = realm.objects("AppLoginStatus");
      const USERTYPE = AppLoginStatus[0]?.userType;

      let body;

      if (USERTYPE === "Customer") {
        body = {
          activityTypeId: "0",
          customerDetailData: {
            emailId: emailId,
            name: name,
            phoneNo: phoneNo,
          },
          licensePlateNumber: "",
          previousPolicyExpired: true,
          quoteNumber: quoteNumber,
        };
      } else if (USERTYPE === "DealerOrAgent") {
        body = {
          activityTypeId: "0",
          customerDetailData: {
            emailId: emailId,
            name: name,
            phoneNo: phoneNo,
            panHolderName: panHolderName,
            panNo: panNo,
          },
          agentId: agentNumber,
          licensePlateNumber: "",
          previousPolicyExpired: true,
          quoteNumber: quoteNumber,
        };
      }
      activityData = await getActivityid({ body });

      //Log firebase events
      logFirebaseEvents();

      console.log("($) => ActivityData => ", activityData);

      registrationNumber = activityData?.additionalActivitiesList.filter(
        (item) => {
          if (item.key == "Registration Number") {
            return item;
          }
        }
      );
      let userNCB = activityData?.additionalActivitiesList.filter((item) => {
        if (item.key == "User NCB") {
          return item;
        }
      });
      setISsLoading(false); // adding data to redux
      dispatch({
        type: "ACTIVITY_DATA",
        payload: {
          activityId: activityData?.activityID,
          activityTypeId: activityData?.activityTypeId,
          licensePlateNumber:
            registrationNumber === undefined ? "" : registrationNumber[0].value,
          toWithQuote: toWithQuote,
          toTutorial: toTutorial,
          quoteNumber: quoteNumber,
        },
      });
      realm.write(() => {
        realm.delete(realm.objects("PIVechicleData"));
        realm.create("PIVechicleData", {
          activityId: activityData?.activityID,
          activityTypeId: activityData?.activityTypeId,
          licensePlateNumber:
            registrationNumber === undefined ? "" : registrationNumber[0].value,
          toWithQuote: toWithQuote,
          toTutorial: toTutorial,
          quoteNumber: quoteNumber,
          ncb:
            userNCB === undefined || userNCB.length == 0
              ? 0
              : Number(userNCB[0].value),
          vechicleType: "",
        });
      });

      realm.write(() => {
        realm.delete(realm.objects("PICompleteStatus"));
        realm.create("PICompleteStatus", {
          piStatus: false,
        });
      });
      // var RealmData = realm.objects("PIVechicleData"); // console.log("&&&&&&&&& ",RealmData);

      navigation.navigate("Toturial", {
        activityId: activityData?.activityID,
        activityTypeId: activityData?.activityTypeId,
        licensePlateNumber: registrationNumber[0]?.value,
      });
    } catch (error) {
      firebaseAttributes(error);
      errorRecord(error);
      console.log("IN WithQuote => error in service ", error);
      setTimeout(() => {
        if (!wrongQuoteModalVisible) {
          setWrongQuoteModalVisible(true);
        }
        //   Alert.alert(
        //     "Oops! Unable to proceed",
        //     "We are experiencing technical issue, Please try after sometime. Or Still You can continue with registration number",
        //     [
        //       {
        //         text: "Cancel",
        //         onPress: () => { },
        //         style: "cancel",
        //       },
        //       {
        //         text: "Continue",
        //         onPress: () => {
        //           navigation.navigate("WithoutQuoteScreen");
        //         },
        //       },
        //     ]
        //   );
      }, 100);
      setISsLoading(false);
    }
  };

  const vechicleTypeModal = () => {
    return (
      <Modal
        isVisible={showOfflineModal}
        headerImageVisible={false}
        shouldHeaderVisible={false}
        onBackdropPress={() => {
          setShowOfflineModal(false);
        }}
      >
        <View>
          <Text style={{ margin: 8, fontSize: 18, fontFamily: "Muli-Regular" }}>
            Please select vechicleType
          </Text>
          <View
            style={{ flexDirection: "row", justifyContent: "space-between" }}
          >
            {/* 4 W */}
            <ProductCard
              imageSource={car}
              title={translate("4 wheeler")}
              key={"4 wheeler"}
              onPress={() => {
                set4wclicked(true);
                set2wclicked(false);
                setCVclicked(false);
                setIsVechicleTypeSelected(true);
                setActivityTypeId(5);
                setVechicleType("FourWheller");
              }}
              style={{
                marginLeft: 8,
                marginBottom: 16,
                width: "30%",
                borderColor: _4Wclicked ? Colors.digitYellow : Colors.greyBlack,
                borderWidth: 1,
                borderRadius: 4,
                backgroundColor: "white",
                marginRight: 8,
              }}
            />

            {/* 2 W */}
            <ProductCard
              imageSource={Bike}
              title={translate("2 wheeler")}
              key={"2 wheeler"}
              onPress={() => {
                set4wclicked(false);
                set2wclicked(true);
                setCVclicked(false);
                setIsVechicleTypeSelected(true);
                setActivityTypeId(26);
                setVechicleType("TwoWheeler");
              }}
              style={{
                marginLeft: 8,
                marginBottom: 16,
                width: "30%",
                borderColor: _2Wclicked ? Colors.digitYellow : Colors.greyBlack,
                borderWidth: 1,
                borderRadius: 4,
                backgroundColor: "white",
                marginRight: 8,
              }}
            />

            {/* cummercial */}
            <ProductCard
              imageSource={cummercial}
              title={translate("Commercial")}
              key={"Commercial"}
              onPress={() => {
                set4wclicked(false);
                set2wclicked(false);
                setCVclicked(true);
                setIsVechicleTypeSelected(true);
                setActivityTypeId(30);
                setVechicleType("Commercial");
              }}
              style={{
                marginLeft: 8,
                marginBottom: 16,
                width: "30%",
                borderColor: cvclicked ? Colors.digitYellow : Colors.greyBlack,
                borderWidth: 1,
                borderRadius: 4,
                backgroundColor: "white",
                marginRight: 8,
              }}
            />
          </View>
          <PrimaryButton
            style={{ margin: 18 }}
            onPress={() => {
              setShowOfflineModal(false);
              saveDataInOfflineDb();
              navigation.navigate("Toturial");
            }}
          >
            Continue
          </PrimaryButton>
        </View>
      </Modal>
    );
  };

  const PreinspectionAlertUx = () => {
    return (
      <View style={{ marginLeft: 16, marginRight: 16 }}>
        <Text
          style={{
            fontSize: 14,
            fontFamily: "Muli-Regular",
            marginBottom: 16,
            lineHeight: 22,
            marginTop: SCREEN_WIDTH / 10,
          }}
        >
          {translate(
            "It seems like you are already in middle of a pre-inspection process You can either continue from where you left off or start from begining"
          )}
        </Text>
        {PICompleteStatus[0]?.piStatus == true ? null : (
          <PrimaryButton
            onPress={() => {
              realmStoreStartOver(false);
              setisPIModalVisible(false);
              navigation.navigate("Toturial", {
                activityId: activityData?.activityID,
                activityTypeId: activityData?.activityTypeId,
                licensePlateNumber: vechicleData[0]?.licensePlateNumber,
              });
              firebaseEvents(
                "Continue_Existing_Flow",
                { quoteNumber: quoteNumber },
                activityData?.activityID,
                activityData?.activityTypeId,
                ""
              );
            }}
          >
            {translate("Continue")}
          </PrimaryButton>
        )}

        <PrimaryButton
          onPress={async () => {
            setisPIModalVisible(false),
              setISsLoading(true),
              await clearAllRealmData(),
              await clearRedux();
            realmStoreStartOver(true);
            callGetActivityid();
            // firebaseEvents(
            //   "Start_Over_New_Flow",
            //   { quoteNumber: quoteNumber },
            //   activityData?.activityID,
            //   activityData?.activityTypeId,
            //   ""
            // );
          }}
          style={{
            backgroundColor: "#FFFFFF",
            borderWidth: 1,
            marginTop: 16,
            marginBottom: SCREEN_WIDTH / 10,
          }}
        >
          {translate("Start Over")}
        </PrimaryButton>
      </View>
    );
  };

  const preInspectionAlert = () => {
    return (
      <View>
        <Modal
          isVisible={isPIModalVisible}
          onBackdropPress={() => setisPIModalVisible(false)}
          onClose={() => isPIModalVisible}
          heading={"Preinspection Alert!"}
          isTranslate={true}
          headerImageVisible={false}
        >
          {PreinspectionAlertUx()}
        </Modal>
      </View>
    );
  };

  const clearAllRealmData = () => {
    try {
      realm.write(() => {
        realm.delete(realm.objects("PIOfflineData"));
      });
      realm.write(() => {
        realm.delete(realm.objects("PIVechicleData"));
      });
      realm.write(() => {
        realm.delete(realm.objects("PIVechicleInstruction"));
      });
      realm.write(() => {
        realm.delete(realm.objects("PIGonePoseDetection"));
        realm.create("PIGonePoseDetection", {
          GoneposeDetectionCount: 0,
        });
      });

      realm.write(() => {
        realm.delete(realm.objects("PIPoseDetectionCompleted"));
        realm.create("PIPoseDetectionCompleted", {
          poseDetectionCompletedCount: 0,
        });
      });

      realm.write(() => {
        realm.delete(realm.objects("PIRetryCount"));
        realm.create("PIRetryCount", {
          retryCount: 0,
          index: 0,
          isAddNewImageData: false,
        });
      });

      realm.write(() => {
        realm.delete(realm.objects("PIclickedCount"));
        realm.create("PIclickedCount", {
          clickedCount: 0,
        });
      });

      realm.write(() => {
        realm.delete(realm.objects("PIUploadedCount"));
        realm.create("PIUploadedCount", {
          uploadedCount: 0,
        });
      });
      realm.write(() => {
        realm.delete(realm.objects("PIMediaStatus"));
      });
    } catch (error) {
      firebaseAttributes(error);
      errorRecord(error);
    }
  };

  const clearRedux = () => {
    dispatch({
      type: "CLEAR_ACTIVITY_DATA",
    });
    dispatch({
      type: "CLEAR_IMAGE_CLICKED_COUNT_REDUX",
    });
    dispatch({
      type: "CLEAR_LAST_DATA_REDUX",
    });
    dispatch({
      type: "CLEAR_SENSOR_DETAILS_REDUX",
    });
    dispatch({
      type: "CLEAR_UPLOAD_IMAGE_REDUX",
    });
    dispatch({
      type: "CLEAR_UPLOAD_IMAGE_DATA_REDUX",
    });
    dispatch({
      type: "CLEAR_VEHICLE_DETAILS_REDUX",
    });
    dispatch({
      type: "CLEAR_RETRY_COUNT_REDUX",
    });
    dispatch({
      type: "CLEAR_RETRY_IMAGE_STATE",
    });
    dispatch({
      type: "CLEAR_RCB_DATA",
    });
  };

  const logFirebaseEvents = () => {
    firebaseEvents(
      "Continue_New_Flow",
      { quoteNumber: quoteNumber },
      activityData?.activityID,
      activityData?.activityTypeId,
      ""
    );
  };

  const checkPICondition = async () => {
    try {
      if (vechicleData[0]?.quoteNumber == quoteNumber && false) {
        // false indicates it will not ask "Continue" option if previously any pre-inspection done
        setisPIModalVisible(true);
      } else {
        setisPIModalVisible(false);
        setISsLoading(true);
        await clearAllRealmData();
        await clearRedux();
        if (isNetworkAvailable) {
          callGetActivityid(); // sending false if it is not offline flow
          showOfflineModal(false);
        } else {
          showOfflineModal(true);
        }
        firebaseEvents(
          "Continue_New_Flow",
          { quoteNumber: quoteNumber },
          activityData?.activityID,
          activityData?.activityTypeId,
          ""
        );
      }
    } catch (error) {
      firebaseAttributes(error);
      errorRecord(error);
    }
  };

  const realmStoreStartOver = (status) => {
    try {
      realm.write(() => {
        realm.delete(realm.objects("PIStartOver"));
        realm.create("PIStartOver", {
          isStartOver: status,
        });
      });
    } catch (error) {
      firebaseAttributes(error);
      errorRecord(error);
    }
  };

  const logutAndNavigate = () => {
    try {
      realm.write(() => {
        realm.delete(realm.objects("AppLoginStatus"));
        realm.create("AppLoginStatus", {
          userType: "Customer",
          isAppLoging: false,
        });
      });
      route.params.props.navigation.navigate("CustomerDetails");
    } catch (error) {
      firebaseAttributes(error);
      errorRecord(error);
      console.log("Error : ", error);
    }
  };

  const logoutAlertModal = () => {
    Alert.alert("Logout", "Are you sure?", [
      {
        text: "Yes",
        onPress: () => {
          UELogEvent("Pressed Yes in Logout Modal", {
            "Quote Value": quoteNumber,
          });
          logutAndNavigate();
        },
        style: "cancel",
      },
      {
        text: "No",
        onPress: () => {
          UELogEvent("Pressed No in Logout Modal", {
            "Quote Value": quoteNumber,
          });
          console.log("on No pressed");
        },
      },
    ]);
  };

  /* Quote failed modal */

  // save vechicle details
  const saveDataInOfflineDb = () => {
    realm.write(() => {
      realm.delete(realm.objects("PIVechicleData"));
      realm.create("PIVechicleData", {
        activityId: 0,
        activityTypeId: activityTypeId,
        licensePlateNumber: "0",
        toWithQuote: toWithQuote,
        toTutorial: toTutorial,
        quoteNumber: quoteNumber,
        ncb: 0,
        vechicleType: "",
      });
    });
  };

  const wrongQuoteNumberModal = () => {
    return (
      <Modal
        isVisible={wrongQuoteModalVisible}
        headerImageVisible={false}
        shouldHeaderVisible={false}
      >
        <View
          style={{
            height: SCREEN_HEIGHT * 0.65,
            flex: 1,
            paddingHorizontal: 16,
            paddingBottom: 16,
            justifyContent: "space-between",
          }}
        >
          <View
            key={"ModalHeader"}
            style={{
              flex: 0.1,
              flexDirection: "row",
              justifyContent: "space-between",
              alignItems: "center",
            }}
          >
            <Text style={[style.muliBoldDB, { fontSize: 18 }]}>OOPS</Text>
            <Icon
              name="close"
              size={24}
              color={Colors.veryLightGray}
              onPress={() => {
                setWrongQuoteModalVisible(false);
              }}
            />
          </View>

          <View style={{ flex: 0.65 }}>
            <Image
              source={{
                uri: "https://d2h44aw7l5xdvz.cloudfront.net/CRM/PRM/oops_something_went_wrong.png",
              }}
              style={styles.wrong}
            />
            <Text style={[style.muliRegDB, { fontSize: 16, marginTop: 24 }]}>
              Looks like you made a mistake entering your policy/quote number.
            </Text>
          </View>

          <View style={{ flex: 0.25, justifyContent: "space-evenly" }}>
            <PrimaryButton
              onPress={() => {
                setWrongQuoteModalVisible(false);
              }}
            >
              Try Again
            </PrimaryButton>
            <PrimaryButton
              onPress={() => {
                setWrongQuoteModalVisible(false),
                  navigation.navigate("WithoutQuoteScreen");
              }}
              mode={"outlined"}
            >
              I don't know my policy/quote no.
            </PrimaryButton>
          </View>
        </View>
      </Modal>
    );
  };

  return (
    <KeyboardAvoidingView
      style={{ flex: 1, backgroundColor: Colors.white }}
      behavior={iOS ? "padding" : ""}
      enabled
    >
      <ScrollView
        style={{ flex: 1, backgroundColor: Colors.white }}
        keyboardShouldPersistTaps={iOS ? "always" : "handled"}
        keyboardDismissMode="on-drag"
      >
        <View style={styles.main}>
          {/* <StencilAnimation/> */}
          <Spinner loading={isLoading} />
          <View style={styles.subView}>
            <Header
              hideArrowBackButton={iOS ? true : false}
              onlanguagechange={() => {
                forceUpdate();
              }}
              onbackPress={() => {
                //call exit alert
                if (Platform.OS === "android") {
                  Alert.alert("Exit Application", "Are you sure?", [
                    {
                      text: "Yes",
                      onPress: () => {
                        BackHandler.exitApp();
                      },
                      style: "cancel",
                    },
                    {
                      text: "No",
                      onPress: () => {
                        console.log("on No pressed");
                      },
                    },
                  ]);
                }

                //   if (toWithQuote) {
                //     if (toTutorial) {
                //       route.params.props.navigation.navigate(
                //         route?.params?.navigateBackToManualPI
                //       );
                //     } else {
                //       route.params.props.navigation.navigate(
                //         route?.params?.navigateBackTo
                //       );
                //     }
                //   } else {
                //     route.params.props.navigation.navigate(
                //       route?.params?.navigateBackToPostplanPreviousPolicy
                //     );
                //   }
                // }}
              }}
              isLogoutVisible={true}
              onLogoutPress={() => {
                UELogEvent("Logout Pressed", {
                  "Message Shown": "Are you sure",
                });

                logoutAlertModal();
              }}
            />
            {/* Image view */}
            <View style={styles.imageView}>
              <Image
                source={girl_selfi}
                style={{
                  resizeMode: "contain",
                  width: "100%",
                  height: (SCREEN_HEIGHT * 20) / 100,
                }}
              />
            </View>
            {/* Text View */}
            <View style={styles.textView}>
              <Text style={styles.welcomeText}>{translate("Welcome!")}</Text>
              <Text style={styles.subText}>
                {
                  "Our pre-inspection process will only take few minutes. All you need to do is upload a video/images of your car. \n\nDon’t worry, we’ll be with you every step of the way!"
                }
              </Text>

              <TextInput
                autoCapitalize="characters"
                label={translate("Enter Quote/Policy number")}
                // value={odometerReadings}
                onChangeText={(value) => {
                  setQuoteNumber(value);
                }}
                errorMsge={
                  quoteNumber.match(POLICY_NUMBER_REGX) == null
                    ? renderErrorMsge({
                        type: "input",
                        text: "quote / policy number",
                      })
                    : null
                }
              />
            </View>
            {preInspectionAlert()}
            {/* Button view */}
            <View style={styles.buttonView}>
              <PrimaryButton
                disabled={quoteNumber.length > 0 ? false : true}
                style={{ marginTop: 24 }}
                onPress={() => {
                  UELogEvent("Clicked on continue", {
                    "Button Title": "Continue",
                    quoteNumber: quoteNumber,
                  });
                  realmStoreStartOver(true);
                  if (isNetworkAvailable) {
                    checkPICondition();
                  } else {
                    setShowOfflineModal(true);
                  }
                }}
              >
                {translate("Continue")}
              </PrimaryButton>
              <RoundButton
                style={{
                  height: 50,
                  borderColor: "#DDDDDD",
                  borderWidth: 1,
                  borderRadius: 16,
                  marginTop: 18,
                  width: SCREEN_WIDTH - 108,
                  alignSelf: "center",
                  justifyContent: "center",
                  marginBottom: 20,
                }}
                Title={translate("Don’t have Quote/Policy No?")}
                onClicked={() => {
                  UELogEvent("Clicked on dont have quote number", {
                    "Button Title": "Don’t have Quote/Policy No?",
                  });
                  navigation.navigate("WithoutQuoteScreen");
                  firebaseEvents(
                    "dont_have_quote_number",
                    { quoteNumber: quoteNumber },
                    activityData?.activityID,
                    activityData?.activityTypeId,
                    ""
                  );
                }}
              ></RoundButton>
              {wrongQuoteNumberModal()}
              {vechicleTypeModal()}
            </View>
          </View>
        </View>
      </ScrollView>
    </KeyboardAvoidingView>
  );
};
export default WithQuote;

const styles = StyleSheet.create({
  container: {
    flex: 1,
    justifyContent: "flex-end",
  },
  main: {
    flex: 1,
    backgroundColor: "#FFFFFF",
  },
  imageView: {
    flex: 0.4,
    justifyContent: "center",
    alignItems: "center",
    marginTop: 50,
  },
  textView: {
    flex: 0.45,
  },
  buttonView: {
    flex: 0.15,
  },
  welcomeText: {
    fontSize: 18,
    fontFamily: "Muli-ExtraBold",
    marginBottom: 9,
    marginTop: 52,
  },
  subText: {
    fontFamily: "Muli-Regular",
    fontSize: 14,
    marginBottom: 23,
  },
  subView: {
    flex: 1,
    marginLeft: 24,
    marginRight: 24,
  },
  wrong: {
    height: "50%",
    width: "50%",
    resizeMode: "contain",
    alignSelf: "center",
  },
});
